<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="记录" prop="recordId">
        <el-input
          v-model="queryParams.recordId"
          placeholder="请输入记录"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>

      <el-form-item label="计划" prop="planId">
        <el-input
          v-model="queryParams.planId"
          placeholder="请输入计划"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="原料" prop="itemId">
        <el-input
          v-model="queryParams.itemId"
          placeholder="请输入原料"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>

      <el-form-item label="记录人" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入记录人"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="投料时间" prop="feedingTime">
        <el-date-picker
          v-model="queryParams.feedingTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          @change="handleQuery"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>

      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['mes:feeding-record-plan:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <!-- <el-table-column label="id" align="center" prop="id" /> -->
      <el-table-column label="记录" align="center" prop="recordCode" />
      <el-table-column label="记录明细" align="center" prop="recordDetailId" />
      <el-table-column label="计划" align="center" prop="planCode" sortable/>
      <el-table-column label="原料" align="center" prop="itemName" />
      <el-table-column label="重量" align="center" prop="weight" />
      <el-table-column label="单位" align="center" prop="unitName" />
      <el-table-column label="记录人" align="center" prop="userName" sortable/>
      <el-table-column
        label="投料时间"
        align="center"
        prop="feedingTime"
        :formatter="dateFormatter"
        width="180px"
      />

      <el-table-column label="操作" align="center">
        <template #default="scope">
<!--          <el-button-->
<!--            link-->
<!--            type="primary"-->
<!--            @click="openForm('update', scope.row.id)"-->
<!--            v-hasPermi="['mes:feeding-record-plan:update']"-->
<!--          >-->
<!--            编辑-->
<!--          </el-button>-->
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['mes:feeding-record-plan:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <FeedingRecordPlanForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { FeedingRecordPlanApi, FeedingRecordPlanVO } from '@/api/mes/feedingplan'
import FeedingRecordPlanForm from './FeedingRecordPlanForm.vue'

/** 投料分配计划 列表 */
defineOptions({ name: 'FeedingRecordPlan' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<FeedingRecordPlanVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  recordId: undefined,
  recordDetailId: undefined,
  planId: undefined,
  itemId: undefined,
  weight: undefined,
  unitId: undefined,
  userId: undefined,
  feedingTime: [],
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await FeedingRecordPlanApi.getFeedingRecordPlanPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await FeedingRecordPlanApi.deleteFeedingRecordPlan(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await FeedingRecordPlanApi.exportFeedingRecordPlan(queryParams)
    download.excel(data, '投料分配计划.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
